section	.text
   global _start        ;must be declared for using gcc
	
_start:	                ;tell linker entry point
    push dword 3        ; Push the second first
    push dword [myzero] ; Push the first parameter
    call _myFunc        ; Call the function
    add esp, 8         ; Release memory
    mov [res], eax      ; Use the returned value

    mov	edx, len
    mov	ecx, msg	
    mov	ebx,1	        ;file descriptor (stdout)
    mov	eax,4	        ;system call number (sys_write)
    int	0x80	        ;call kernel

    mov	edx, 1
    mov	ecx, res
    mov	ebx, 1	        ;file descriptor (stdout)
    mov	eax, 4	        ;system call number (sys_write)
    int	0x80	        ;call kernel

    xor  ebx,ebx	
    mov	eax,1	        ;system call number (sys_exit)
    int	0x80	        ;call kernel

_myFunc:
    ; Subroutine Prologue
    push ebp     ; Save the old base pointer value.
    mov ebp, esp ; Set the new base pointer value.
    sub esp, 4   ; Make room for one 4-byte local variable.
    push edi     ; Save the values of registers that the function
    push esi     ; will modify. This function uses EDI and ESI.

    ; Subroutine Body
    mov esi, [ebp+8]   ; Move value of parameter 1 into ESI
    mov edi, [ebp+12]  ; Move value of parameter 2 into EDI

    mov [ebp-4], edi   ; Move EDI into the local variable
    add [ebp-4], esi   ; Add ESI into the local variable

    ; Subroutine Epilogue 
    mov eax, [ebp-4]   ; Store result into EAX
    pop esi            ; Recover register values
    pop edi
    leave              ; mov esp, ebp ; Deallocate local variables
                       ; pop ebp      ; Restore the caller's base pointer value
    ret

section .data
msg db "The result is: "
len equ $- msg   
myzero db '0'

segment .bss
res resb 1
